; 
    include \masm32\include\masm32rt.inc
; 
    .data
      displayName db "Test",0
      className   db "test_class",0
      text        db "password",0
    .code
; 

;------------------------------------------------------------------
; This is the callback function that processes messages sent to
; the window. In most cases, your code should return zero whether
; it processes a message or not. For the details see the API
; documentation for the message. Any messages not processed should
; normally be passed to the default window procedure, and then
; whatever it returns should be returned to the system.
;------------------------------------------------------------------

WindowProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg == WM_CREATE

      ;---------------------------------------------------
      ; The WM_CREATE message is sent after the window is
      ; created, and before it is made visible.
      ;---------------------------------------------------

      ;-------------------------------------------------
      ; Create a single line edit control with a border
      ; and the ES_PASSWORD style. The control must be
      ; a child of the main window and must be visible.
      ;-------------------------------------------------

      invoke GetModuleHandle, NULL

      STYLE = WS_CHILDWINDOW or WS_VISIBLE or ES_PASSWORD
    
      invoke CreateWindowEx, WS_EX_CLIENTEDGE,
                             chr$("EDIT"),
                             ADDR text,
                             STYLE,
                             25, 30, 100, 25,
                             hWnd,
                             1000, eax, NULL
      ret                             

    .ELSEIF uMsg == WM_CLOSE

      ;---------------------------------------------------------
      ; The WM_CLOSE message is sent when the user clicks the
      ; Close button at the right end of the title bar, selects
      ; Close on the Window menu, or presses Alt+F4.
      ;
      ; DestroyWindow will automatically destroy any child
      ; windows before it destroys the parent.
      ;---------------------------------------------------------

      invoke DestroyWindow, hWnd

    .ELSEIF uMsg == WM_DESTROY

      ;---------------------------------------------------------
      ; The WM_DESTROY message is sent when the window is being
      ; destroyed, and it must be handled to ensure that the
      ; application exits properly. PostQuitMessage posts a
      ; WM_QUIT message to the message queue.
      ;---------------------------------------------------------

      invoke PostQuitMessage, NULL

    .ELSE

      invoke DefWindowProc, hWnd, uMsg, wParam, lParam
      ret

    .ENDIF

    xor eax, eax
    ret

WindowProc endp

; 

;--------------------------------------------------------------------
; This procedure creates and displays the window and then enters the
; message loop, executing there until the user closes the window.
;
; This procedure is structured like and serves the same purpose as
; the WinMain function of a C application:
;
;   http://msdn2.microsoft.com/en-us/library/ms633559.aspx 
;
;--------------------------------------------------------------------

WinMain proc hInstance:HINSTANCE,
             hPrevInstance:HINSTANCE,
             lpCmdLine:LPSTR,
             nCmdShow:DWORD

    LOCAL hWnd:HWND
    LOCAL wMsg:MSG
    LOCAL _x:DWORD
    LOCAL _y:DWORD
    LOCAL wcx:WNDCLASSEX

    ;------------------------------------
    ; Populate the WNDCLASSEX structure.
    ;------------------------------------

    mov wcx.cbSize, SIZEOF WNDCLASSEX
    mov wcx.style, CS_HREDRAW or CS_VREDRAW
    mov wcx.lpfnWndProc, OFFSET WindowProc
    mov wcx.cbClsExtra, NULL
    mov wcx.cbWndExtra, NULL
    push hInstance
    pop wcx.hInstance
    invoke LoadIcon, NULL, IDI_APPLICATION
    mov wcx.hIcon, eax
    invoke LoadCursor, NULL, IDC_ARROW
    mov wcx.hCursor, eax
    mov wcx.hbrBackground, COLOR_WINDOW+1
    mov wcx.lpszMenuName, NULL
    mov wcx.lpszClassName, OFFSET className
    mov wcx.hIconSm, 0

    ;-------------------------------
    ; And register it with Windows.
    ;-------------------------------

    invoke RegisterClassEx, ADDR wcx

    ;-----------------------------------------
    ; Specify the window size and calc the
    ; coordinates to center it on the screen.
    ;-----------------------------------------

    W = 160
    H = 120
    invoke GetSystemMetrics, SM_CXSCREEN
    shr eax, 1
    sub eax, W / 2
    mov _x, eax
    invoke GetSystemMetrics, SM_CXSCREEN
    shr eax, 1
    sub eax, H / 2
    mov _y, eax

    ;----------------------------------------
    ; Create the window and save the handle.
    ;----------------------------------------

    invoke CreateWindowEx, WS_EX_OVERLAPPEDWINDOW,
                           ADDR className,
                           ADDR displayName,
                           WS_OVERLAPPED or WS_SYSMENU,
                           _x, _y, W, H,
                           NULL, NULL,
                           hInstance, NULL
    mov hWnd, eax

    ;-----------------------------------------
    ; Set the window's show state and send it
    ; its first WM_PAINT message.
    ;-----------------------------------------

    invoke ShowWindow, hWnd, nCmdShow
    invoke UpdateWindow, hWnd

    ;--------------------------------------------------------------
    ; This is a normal message loop. GetMessage retrieves messages
    ; from the calling threads message queue, returning zero when
    ; it retrieves a WM_QUIT message. If no message is available
    ; GetMessage waits for one to be posted before it returns.
    ; TranslateMessage translates virtual key messages to
    ; character messages. DispatchMessage dispatches the message
    ; to the window procedure.
    ;--------------------------------------------------------------

  msgloop:

    invoke GetMessage, ADDR wMsg, NULL, 0, 0
    .IF eax != 0
      invoke TranslateMessage, ADDR wMsg
      invoke DispatchMessage, ADDR wMsg
      jmp msgloop
    .ENDIF

    ;--------------------------------------------------------
    ; Return the exit code, specified in the PostQuitMessage
    ; call in WindowProc, to the system.
    ;--------------------------------------------------------

    mov eax, wMsg.wParam
    ret

WinMain endp

; 
start:
; 

    ;---------------------------------------------------------------
    ; Under Windows XP, to enable the visual styles your app must
    ; use ComCtl32.dll Version 6 or later. To do this you must add
    ; add an application manifest, and call InitCommonControls to
    ; to register and initialize the common control window classes.
    ;---------------------------------------------------------------    

    invoke InitCommonControls

    ;--------------------------------------------------------------
    ; This code sets up and calls WinMain, passing it essentially
    ; the same values that the RTL startup code would pass in a C
    ; application. A null is passed in the hPrevInstance parameter
    ; because it is obsolete.
    ;--------------------------------------------------------------

    invoke GetCommandLine
    push eax
    invoke GetModuleHandle, NULL
    pop edx

    invoke WinMain, eax, NULL, edx, SW_SHOWDEFAULT

    invoke ExitProcess, 0
 
; 
end start